diff --git a/src/backend/replication/logical/proto.c b/src/backend/replication/logical/proto.c
index 62275ebabe..f2c85cabb5 100644
--- a/src/backend/replication/logical/proto.c
+++ b/src/backend/replication/logical/proto.c
@@ -493,7 +493,6 @@ logicalrep_write_tuple(StringInfo out, Relation rel, HeapTuple tuple, bool binar
                HeapTuple       typtup;
                Form_pg_type typclass;
                Form_pg_attribute att = TupleDescAttr(desc, i);
-               char       *outputstr;

                if (att->attisdropped || att->attgenerated)
                        continue;
@@ -537,6 +536,8 @@ logicalrep_write_tuple(StringInfo out, Relation rel, HeapTuple tuple, bool binar
                }
                else
                {
+                       char       *outputstr;
+
                        pq_sendbyte(out, LOGICALREP_COLUMN_TEXT);
                        outputstr = OidOutputFunctionCall(typclass->typoutput, values[i]);
                        pq_sendcountedtext(out, outputstr, strlen(outputstr), false);